/// This file has been automatically generated. DO NOT EDIT.
/// The generation code is located in the `codegen` crate.

/// Format of a Bandcamp image
///
/// Formats with both a width (`W`) and height (`H`) specification are cropped to the
/// specified dimensions.
///
/// Formats with either a width or height specification are scaled.
#[derive(Default, Debug, Copy, Clone, PartialEq, Eq)]
#[non_exhaustive]
#[allow(missing_docs)]
pub enum ImageFormat {
    #[default]
    OriginalPng,
    W350H350Jpg,
    W100H100Jpg,
    W300H300Jpg,
    W700H700Jpg,
    W150H150Jpg,
    W124H124Jpg,
    W210H210Jpg,
    W1200Jpg,
    W172H172Jpg,
    W138H138Jpg,
    W380H380Jpg,
    W368H368Jpg,
    W135H135Jpg,
    W1024Jpg,
    W120Jpg,
    W25H25Jpg,
    W300Jpg,
    W700Jpg,
    W800H600Jpg,
    W715H402Jpg,
    W768H432Jpg,
    W100H75Jpg,
    W1024Png,
    W380H285Jpg,
    W368H276Jpg,
    W400H300Jpg,
    W168H126Jpg,
    W144H108Jpg,
    W50H50Jpg,
    H100Jpg,
    H200Jpg,
    W140H140Jpg,
    W975H180Png,
    H90Jpg,
    W640H124Jpg,
    OriginalJpg,
    W60H45Jpg,
    W1280H720Jpg,
    W720H1280Jpg,
    W60H100Jpg,
    W40H80Jpg,
    H420Jpg,
    H280Jpg,
    H140Jpg,
    H360Jpg,
    H240Jpg,
    H180Jpg,
    H120Jpg,
    W900H468Jpg,
}

impl ImageFormat {
    /// Get the Bandcamp image format number
    ///
    /// Example: nr=10, url=`https://f4.bcbits.com/img/24132920_<NR>`
    pub(crate) fn nr(&self) -> u16 {
        match self {
            ImageFormat::OriginalPng => 1,
            ImageFormat::W350H350Jpg => 2,
            ImageFormat::W100H100Jpg => 3,
            ImageFormat::W300H300Jpg => 4,
            ImageFormat::W700H700Jpg => 5,
            ImageFormat::W150H150Jpg => 7,
            ImageFormat::W124H124Jpg => 8,
            ImageFormat::W210H210Jpg => 9,
            ImageFormat::W1200Jpg => 10,
            ImageFormat::W172H172Jpg => 11,
            ImageFormat::W138H138Jpg => 12,
            ImageFormat::W380H380Jpg => 13,
            ImageFormat::W368H368Jpg => 14,
            ImageFormat::W135H135Jpg => 15,
            ImageFormat::W1024Jpg => 20,
            ImageFormat::W120Jpg => 21,
            ImageFormat::W25H25Jpg => 22,
            ImageFormat::W300Jpg => 23,
            ImageFormat::W700Jpg => 25,
            ImageFormat::W800H600Jpg => 26,
            ImageFormat::W715H402Jpg => 27,
            ImageFormat::W768H432Jpg => 28,
            ImageFormat::W100H75Jpg => 29,
            ImageFormat::W1024Png => 31,
            ImageFormat::W380H285Jpg => 32,
            ImageFormat::W368H276Jpg => 33,
            ImageFormat::W400H300Jpg => 36,
            ImageFormat::W168H126Jpg => 37,
            ImageFormat::W144H108Jpg => 38,
            ImageFormat::W50H50Jpg => 42,
            ImageFormat::H100Jpg => 43,
            ImageFormat::H200Jpg => 44,
            ImageFormat::W140H140Jpg => 50,
            ImageFormat::W975H180Png => 100,
            ImageFormat::H90Jpg => 101,
            ImageFormat::W640H124Jpg => 120,
            ImageFormat::OriginalJpg => 130,
            ImageFormat::W60H45Jpg => 140,
            ImageFormat::W1280H720Jpg => 150,
            ImageFormat::W720H1280Jpg => 151,
            ImageFormat::W60H100Jpg => 160,
            ImageFormat::W40H80Jpg => 161,
            ImageFormat::H420Jpg => 200,
            ImageFormat::H280Jpg => 201,
            ImageFormat::H140Jpg => 202,
            ImageFormat::H360Jpg => 204,
            ImageFormat::H240Jpg => 205,
            ImageFormat::H180Jpg => 206,
            ImageFormat::H120Jpg => 207,
            ImageFormat::W900H468Jpg => 220,
        }
    }
}
